using System;
using System.Runtime.InteropServices;

/// <summary>
/// EPX-64R API library definitions
/// </summary>
public class EPX64R
{
    // Device status (Return codes)
    public const int EPX64R_OK = 0;
    public const int EPX64R_INVALID_HANDLE = 1;
    public const int EPX64R_DEVICE_NOT_FOUND = 2;
    public const int EPX64R_DEVICE_NOT_OPENED = 3;
    public const int EPX64R_OTHER_ERROR = 4;
    public const int EPX64R_COMMUNICATION_ERROR = 5;
    public const int EPX64R_INVALID_PARAMETER = 6;

    // Constants
    public const byte EPX64R_PORT0 = 0x01;
    public const byte EPX64R_PORT1 = 0x02;
    public const byte EPX64R_PORT2 = 0x04;
    public const byte EPX64R_PORT3 = 0x08;
    public const byte EPX64R_PORT4 = 0x10;
    public const byte EPX64R_PORT5 = 0x20;
    public const byte EPX64R_PORT6 = 0x40;
    public const byte EPX64R_PORT7 = 0x80;

   // Function definitions
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_GetNumberOfDevices (ref int Number);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_GetSerialNumber (int Index, ref int SerialNumber);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_Open (ref System.IntPtr Handle);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_OpenBySerialNumber (int SerialNumber, ref System.IntPtr Handle);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_Close (System.IntPtr Handle);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_SetDirection (System.IntPtr Handle, byte Direction);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_GetDirection (System.IntPtr Handle, ref byte Direction);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_OutputPort (System.IntPtr Handle, byte Port, byte Value);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_InputPort (System.IntPtr Handle, byte Port, ref byte Value);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_SetPortOutputBuffer (System.IntPtr Handle, byte Port, byte Value);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_GetPortInputBuffer(System.IntPtr Handle, byte Port, ref byte Value);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_SetInputLatch(System.IntPtr Handle);
    [DllImport("EPX64R.dll")]
    public static extern int EPX64R_SetOutputLatch(System.IntPtr Handle);
}
