Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

Module EPX64R

    ' Device status (Return codes)
    Public Const EPX64R_OK As Integer = 0
    Public Const EPX64R_INVALID_HANDLE As Integer = 1
    Public Const EPX64R_DEVICE_NOT_FOUND As Integer = 2
    Public Const EPX64R_DEVICE_NOT_OPENED As Integer = 3
    Public Const EPX64R_OTHER_ERROR As Integer = 4
    Public Const EPX64R_COMMUNICATION_ERROR As Integer = 5
    Public Const EPX64R_INVALID_PARAMETER As Integer = 6

    ' Constants
    Public Const EPX64R_PORT0 As Byte = &H1
    Public Const EPX64R_PORT1 As Byte = &H2
    Public Const EPX64R_PORT2 As Byte = &H4
    Public Const EPX64R_PORT3 As Byte = &H8
    Public Const EPX64R_PORT4 As Byte = &H10
    Public Const EPX64R_PORT5 As Byte = &H20
    Public Const EPX64R_PORT6 As Byte = &H40
    Public Const EPX64R_PORT7 As Byte = &H80

    ' Function definitions
    Public Declare Function EPX64R_GetNumberOfDevices Lib "EPX64R.dll" (ByRef Number As Integer) As Integer
    Public Declare Function EPX64R_GetSerialNumber Lib "EPX64R.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function EPX64R_Open Lib "EPX64R.dll" (ByRef Handle As System.IntPtr) As Integer
    Public Declare Function EPX64R_OpenBySerialNumber Lib "EPX64R.dll" (ByVal SerialNumber As Integer, ByRef Handle As System.IntPtr) As Integer
    Public Declare Function EPX64R_Close Lib "EPX64R.dll" (ByVal Handle As System.IntPtr) As Integer
    Public Declare Function EPX64R_SetDirection Lib "EPX64R.dll" (ByVal Handle As System.IntPtr, ByVal Direction As Byte) As Integer
    Public Declare Function EPX64R_GetDirection Lib "EPX64R.dll" (ByVal Handle As System.IntPtr, ByRef Direction As Byte) As Integer
    Public Declare Function EPX64R_OutputPort Lib "EPX64R.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByVal Value As Byte) As Integer
    Public Declare Function EPX64R_InputPort Lib "EPX64R.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByRef Value As Byte) As Integer
    Public Declare Function EPX64R_SetPortOutputBuffer Lib "EPX64R.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByVal Value As Byte) As Integer
    Public Declare Function EPX64R_GetPortInputBuffer Lib "EPX64R.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByRef Value As Byte) As Integer
    Public Declare Function EPX64R_SetOutputLatch Lib "EPX64R.dll" (ByVal Handle As System.IntPtr) As Integer
    Public Declare Function EPX64R_SetInputLatch Lib "EPX64R.dll" (ByVal Handle As System.IntPtr) As Integer

End Module
